侧边栏壁纸
  • 累计撰写 71 篇文章
  • 累计创建 87 个标签
  • 累计收到 5 条评论

目 录CONTENT

文章目录

Golang升级1.18之后panic()报错

KunkkaWu
2023-03-17 / 0 评论 / 1 点赞 / 5,494 阅读 / 366 字 / 正在检测是否收录...

报错:

本地Golang升级到1.18后,发现原本写的一些代码在Goland中出现了一些红色的波浪线,将鼠标移到错误提示上,有如下的显示:

Cannot use 'err' (type error) as the type any

image

源代码:

conn, err := listener.Accept()
if err != nil {
    panic(err)   // 1.18后Goland会报错,hong
}
buf := make([]byte, 1024)

原因

Golang 1.18 版本开始引入any类型可以替代空接口 interface{}

解决

var err any = "异常报错"
panic(err)

//或者
panic(any("异常报错"))

但是很奇怪 ?

代码在执行的时候并没有报错,而仅仅是在Goland中会有这个错误提示呢?

有没有一种可能是,Goland版本低了对Go 1.18的新特性支持的不是很友好呢?

搜索Goland发布日志

image

点击Release Nodes进入发布日志

image

发现确实有这么一条更新日志:

Go 1.18 Generics: Type any isn’t properly supported: Cannot use … (type string) as the type any

划重点

那就是说明在Go 1.18版本之后,Goland的2021.3.3之前的版本都会有这个BUG。

尝试升级Goland版本

image

image

升级完成后解决问题

image

总结

以上两种方式都可以解决golang1.18版本后,goland中panic(err) 对string类型检查报错的问题。

但是最好还是去升级一下Goland,这样对代码会更友好一些。

1

评论区